#hcharvat <- function(freq.abs, alpha = 2)
#{
#  if (alpha <= 0) stop("El parmetre alpha de Havrda-Charvat ha de ser positiu")
#  freq.rels <- freq.abs / sum(freq.abs)
#  suma <- 0
#  for (i in 1:length(freq.rels))
#  {
#    suma <- suma + freq.rels[i]^alpha
#  }
#  return((1 - suma) / (alpha - 1))
#}

hcharvat <- function(freq.abs, alpha = 2)
{
  if (alpha <= 0) stop("El parmetre alpha de Havrda-Charvat ha de ser positiu")
  return((1 - sum((freq.abs / sum(freq.abs))^alpha)) / (alpha - 1))
}

renyi <- function(freq.abs, alpha = 2)
{
  if (alpha <= 0) stop("El parmetre alpha de Renyi ha de ser positiu")
  return(log(sum((freq.abs / sum(freq.abs))^alpha)) / (1 - alpha))
}

shannon <- function(freq.abs)
{
	freq.rels = freq.abs / sum(freq.abs)
	- sum(ifelse(freq.rels > 0, freq.rels * log2(freq.rels), 0))
}

all.divers <- function(freq.abs, alpha = 2)
{
  if (alpha <= 0) stop("El parmetre alpha de Renyi o Havrda-Charvat ha de ser positiu")
  result <- c(shannon(freq.abs), hcharvat(freq.abs,alpha), renyi(freq.abs,alpha))
  names(result) <- c("Shannon", "Havrda-Charvat", "Renyi")
  return(result)
}

